_The following article is an adaption of the article “Copying
conditions for TeX Live” (reference given at the end)._

## Copying conditions for MiKTeX

To the best of our knowledge, all software in the MiKTeX distribution
is freely redistributable (libre, that is, not necessarily gratis),
within the Free Software Foundation's definition and the Debian Free
Software Guidelines. Where the two conflict, we generally follow the
FSF. If you find any non-free files included, please contact us
(reference given at the end).

That said, MiKTeX has neither a single copyright holder nor a single
license covering its entire contents, since it is a collection of many
independent packages. Therefore, you may copy, modify, and/or
redistribute software from MiKTeX only if you comply with the
requirements placed thereon by the owners of the respective packages.

To most easily learn these requirements, we suggest checking the
MiKTeX package catalogue (reference given at the end). Of course the
legal statements within the packages themselves are the final
authority.

### Guidelines for redistribution

In general, you may redistribute MiKTeX, with or without modification,
for profit or not, according to the usual free software tenets. Here
are some general guidelines for doing this:

* If you make any changes to the MiKTeX distribution or any package it
  contains, besides complying with any licensing requirements, you
  must prominently mention such changes in your modified distribution
  so that users do not take your work for ours, and know to contact
  you, not us, in case of questions or problems.

* Especially (but not necessarily) if changes or additions are made,
  we recommend a clearly different title, such as “Your work, based on
  MiKTeX x.y.zzzz”, where x.y.zzzz is the Git tag of the MiKTeX
  version you are using. This credits both our work and yours.

* You absolutely may not place your own copyright on the entire
  distribution, since it is not your work. Statements such as “all
  rights reserved” and “may not be reproduced” are especially
  reprehensible, since they are antithetical to the free software
  principles under which MiKTeX is produced.

* You may use any cover or media label designs that you wish. Such
  packaging and marketing details are not covered by any MiKTeX
  license.

* Finally, we make the following requests (not legal requirements):

  a. Acknowledging that the MiKTeX distribution is developed as a
     joint effort by all TeX user groups, and encouraging the
     user/reader to join their user group of choice, as listed on the
     web page <http://www.tug.org/usergroups.html>.

  b. Referencing the MiKTeX project page: <https://miktex.org/>.

  Such information may be placed on the label of your media, your
  cover, and/or in accompanying text (for instance, in the
  acknowledgements section of a book).

Finally, although it is certainly not a requirement, we'd like to
invite any redistributors to make a donation to the project, whether
cash or in-kind, for example via
<https://miktex.org/giveback>. Thanks.

### References

1. MiKTeX project contact form: <https://miktex.org/email/>
2. MiKTeX package catalogue: <https://miktex.org/packages/>
3. Copying conditions for TeX Live: <http://tug.org/texlive/LICENSE.TL>
4. The FSF's free software definition: <https://www.gnu.org/philosophy/free-sw.html>
5. Debian Free Software Guidelines: <https://www.debian.org/intro/free>
6. FSF commentary on existing licenses: <https://www.gnu.org/licenses/license-list.html>
